//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2013 by Eran Ifrah
// file name            : ps_completion_page.h
//
// -------------------------------------------------------------------------
// A
//              _____           _      _     _ _
//             /  __ \         | |    | |   (_) |
//             | /  \/ ___   __| | ___| |    _| |_ ___
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/
//              \____/\___/ \__,_|\___\_____/_|\__\___|
//
//                                                  F i l e
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifndef __ps_completion_page__
#define __ps_completion_page__

/**
@file
Subclass of PSCompletionBase, which is generated by wxFormBuilder.
*/

#include "project_settings_base_dlg.h"
#include "project_settings_dlg.h"

class ProjectSettingsDlg;

//// end generated include

/** Implementing PSCompletionBase */
class PSCompletionPage : public PSCompletionBase, public IProjectSettingsPage
{
protected:
    virtual void OnProjectEnabledUI(wxUpdateUIEvent& event);
    ProjectSettingsDlg* m_dlg;
    bool                m_ccSettingsModified;

protected:
    // Handlers for PSCompletionBase events.
    void OnCmdEvtVModified( wxCommandEvent& event );
    void OnBrowsePCH(wxCommandEvent& event);

public:
    /** Constructor */
    PSCompletionPage( wxWindow* parent, ProjectSettingsDlg* dlg );
    //// end generated class members

    virtual void Clear();
    virtual void Load(BuildConfigPtr buildConf);
    virtual void Save(BuildConfigPtr buildConf, ProjectSettingsPtr projSettingsPtr);

};

#endif // __ps_completion_page__
