//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2009 by Eran Ifrah
// file name            : svn_preferences_dialog.h
//
// -------------------------------------------------------------------------
// A
//              _____           _      _     _ _
//             /  __ \         | |    | |   (_) |
//             | /  \/ ___   __| | ___| |    _| |_ ___
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/
//              \____/\___/ \__,_|\___\_____/_|\__\___|
//
//                                                  F i l e
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifndef __svn_preferences_dialog__
#define __svn_preferences_dialog__

/**
@file
Subclass of SvnPreferencesDialogBase, which is generated by wxFormBuilder.
*/

#include "subversion2_ui.h"
class Subversion2;

/** Implementing SvnPreferencesDialogBase */
class SvnPreferencesDialog : public SvnPreferencesDialogBase
{
	Subversion2 *m_plugin;
protected:
	// Handlers for SvnPreferencesDialogBase events.
	void OnBrowseSvnExe    ( wxCommandEvent& event );
	void OnBrowseDiffViewer( wxCommandEvent& event );
	void OnBrowseSSHClient ( wxCommandEvent& event );
	void OnButtonOK        ( wxCommandEvent &event );
	void OnUseExternalDiffUI( wxUpdateUIEvent &event);
	void OnAddRevisionMacroUI( wxUpdateUIEvent& event );

protected:
	wxString DoGetExecutable(const wxString &basePath);

public:
	/** Constructor */
	SvnPreferencesDialog( wxWindow* parent, Subversion2 *plugin );
	virtual ~SvnPreferencesDialog();
};

#endif // __svn_preferences_dialog__
